#include <AccelStepper.h>
#include <WiFi.h>
#include <AsyncTCP.h>
#include <SPIFFS.h>
#include <ESPAsyncWebServer.h>
AsyncWebServer server(80);

// REPLACE WITH YOUR NETWORK CREDENTIALS
const char* ssid = "NoVirus";
const char* password = "password";

const char* PARAM_STRING = "inputString";
const char* PARAM_INT = "inputInt";
const char* PARAM_FLOAT = "inputFloat";

const int analogInputPin = 33;
//AccelStepper stepper1(1, 26, 25);  //StepPin D2 and DirPin D3

//we use the button and try to prevent flickering
const int BUTTON_PIN_LEFT = 0;        // the number of the pushbutton pin
const int BUTTON_PIN_RIGHT = 35;
const int DEBOUNCE_DELAY = 50;   // the debounce time; increase if the output flickers

// Variables will change:
int lastSteadyState_LEFT = LOW;       // the previous steady state from the input pin
int lastSteadyState_RIGHT = LOW; 
int lastFlickerableState_LEFT = LOW;  // the previous flickerable state from the input pin
int lastFlickerableState_RIGHT = LOW;
int currentState_LEFT;                // the current reading from the input pin
int currentState_RIGHT;

// the following variables are unsigned longs because the time, measured in
// milliseconds, will quickly become a bigger number than can be stored in an int.
unsigned long lastDebounceTime_LEFT = 0;  // the last time the output pin was toggled
unsigned long lastDebounceTime_RIGHT = 0;


void setup()
{  
  Serial.begin(115200);
  //SetupWebServer();
  pinMode(BUTTON_PIN_LEFT, INPUT_PULLUP);pinMode(BUTTON_PIN_RIGHT, INPUT_PULLUP);
  //stepper1.setMaxSpeed(1000);
  //stepper1.setCurrentPosition(0);
  //stepper1.setAcceleration(1);
  //stepper1.setSpeed(400);
  //stepper1.moveTo(500);
    //One full rotation = 800 steps = 200 steps * 4 (MS1=0, MS2=1, MS3=0)
  //stepper1.setCurrentPosition(0);
}

void loop()
{  
  ButtonRead();
  //stepper1.runSpeed();
}


void ButtonRead(){
currentState_LEFT = digitalRead(BUTTON_PIN_LEFT);
  currentState_RIGHT = digitalRead(BUTTON_PIN_RIGHT);

  if (currentState_LEFT != lastFlickerableState_LEFT) {
    // reset the debouncing timer
    lastDebounceTime_LEFT = millis();
    // save the the last flickerable state
    lastFlickerableState_LEFT = currentState_LEFT;
  }
  if (currentState_RIGHT != lastFlickerableState_RIGHT) {
    lastDebounceTime_RIGHT = millis();
    lastFlickerableState_RIGHT = currentState_RIGHT;
  }

  if ((millis() - lastDebounceTime_LEFT) > DEBOUNCE_DELAY) {
    // whatever the reading is at, it's been there for longer than the debounce
    // delay, so take it as the actual current state:
    // if the button state has changed:
    if (lastSteadyState_LEFT == HIGH && currentState_LEFT == LOW)
      {Serial.println("The left button is pressed");}
    else if (lastSteadyState_LEFT == LOW && currentState_LEFT == HIGH)
      {Serial.println("The left button is released");run(200,0);}
    // save the the last steady state
    lastSteadyState_LEFT = currentState_LEFT;
  }
  if ((millis() - lastDebounceTime_RIGHT) > DEBOUNCE_DELAY) {
    // whatever the reading is at, it's been there for longer than the debounce
    // delay, so take it as the actual current state:
    // if the button state has changed:
    if (lastSteadyState_RIGHT == HIGH && currentState_RIGHT == LOW)
      {Serial.println("The right button is pressed");}
    else if (lastSteadyState_RIGHT == LOW && currentState_RIGHT == HIGH)
      {Serial.println("The right button is released");
      run(200,1);
  
      }
    // save the the last steady state
    lastSteadyState_RIGHT = currentState_RIGHT;
  }
}


void run(int step,bool dir){
digitalWrite(25, dir);
Serial.println("tourne");
      for (int i = 0; i < step; ++i) {
    digitalWrite(26, HIGH);
    delayMicroseconds(500);
    digitalWrite(26, LOW);
    delayMicroseconds(500);
}}

// HTML web page to handle 3 input fields (inputString, inputInt, inputFloat)
const char index_html[] PROGMEM = R"rawliteral(
<!DOCTYPE HTML><html><head>
  <title>ESP Input Form</title>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script>
    function submitMessage() {
      alert("Saved value to ESP SPIFFS");
      setTimeout(function(){ document.location.reload(false); }, 500);   
    }
  </script></head><body>
  <form action="/get" target="hidden-form">
    inputString (current value %inputString%): <input type="text" name="inputString">
    <input type="submit" value="Submit" onclick="submitMessage()">
  </form><br>
  <form action="/get" target="hidden-form">
    inputInt (current value %inputInt%): <input type="number " name="inputInt">
    <input type="submit" value="Submit" onclick="submitMessage()">
  </form><br>
  <form action="/get" target="hidden-form">
    inputFloat (current value %inputFloat%): <input type="number " name="inputFloat">
    <input type="submit" value="Submit" onclick="submitMessage()">
  </form>
  <iframe style="display:none" name="hidden-form"></iframe>
</body></html>)rawliteral";

void SetupWebServer() {
  #ifdef ESP32
    if(!SPIFFS.begin(true)){
      Serial.println("An Error has occurred while mounting SPIFFS");
      return;
    }
  #else
    if(!SPIFFS.begin()){
      Serial.println("An Error has occurred while mounting SPIFFS");
      return;
    }
  #endif

  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  if (WiFi.waitForConnectResult() != WL_CONNECTED) {
    Serial.println("WiFi Failed!");
    return;
  }
  Serial.println();
  Serial.print("IP Address: ");
  Serial.println(WiFi.localIP());

  // Send web page with input fields to client
  server.on("/", HTTP_GET, [](AsyncWebServerRequest *request){
    request->send_P(200, "text/html", index_html, processor);
  });

  // Send a GET request to <ESP_IP>/get?inputString=<inputMessage>
  server.on("/get", HTTP_GET, [] (AsyncWebServerRequest *request) {
    String inputMessage;
    // GET inputString value on <ESP_IP>/get?inputString=<inputMessage>
    if (request->hasParam(PARAM_STRING)) {
      inputMessage = request->getParam(PARAM_STRING)->value();
      writeFile(SPIFFS, "/inputString.txt", inputMessage.c_str());
    }
    // GET inputInt value on <ESP_IP>/get?inputInt=<inputMessage>
    else if (request->hasParam(PARAM_INT)) {
      inputMessage = request->getParam(PARAM_INT)->value();
      writeFile(SPIFFS, "/inputInt.txt", inputMessage.c_str());
    }
    // GET inputFloat value on <ESP_IP>/get?inputFloat=<inputMessage>
    else if (request->hasParam(PARAM_FLOAT)) {
      inputMessage = request->getParam(PARAM_FLOAT)->value();
      writeFile(SPIFFS, "/inputFloat.txt", inputMessage.c_str());
    }
    else {
      inputMessage = "No message sent";
    }
    Serial.println(inputMessage);
    request->send(200, "text/text", inputMessage);
  });
  server.onNotFound(notFound);
  server.begin();
}



void notFound(AsyncWebServerRequest *request) {
  request->send(404, "text/plain", "Not found");
}

String readFile(fs::FS &fs, const char * path){
  Serial.printf("Reading file: %s\r\n", path);
  File file = fs.open(path, "r");
  if(!file || file.isDirectory()){
    Serial.println("- empty file or failed to open file");
    return String();
  }
  Serial.println("- read from file:");
  String fileContent;
  while(file.available()){
    fileContent+=String((char)file.read());
  }
  file.close();
  Serial.println(fileContent);
  return fileContent;
}

void writeFile(fs::FS &fs, const char * path, const char * message){
  Serial.printf("Writing file: %s\r\n", path);
  File file = fs.open(path, "w");
  if(!file){
    Serial.println("- failed to open file for writing");
    return;
  }
  if(file.print(message)){
    Serial.println("- file written");
  } else {
    Serial.println("- write failed");
  }
  file.close();
}

// Replaces placeholder with stored values
String processor(const String& var){
  //Serial.println(var);
  if(var == "inputString"){
    return readFile(SPIFFS, "/inputString.txt");
  }
  else if(var == "inputInt"){
    return readFile(SPIFFS, "/inputInt.txt");
  }
  else if(var == "inputFloat"){
    return readFile(SPIFFS, "/inputFloat.txt");
  }
  return String();
}
